const _Http = getApp().globalData.http;
let sa_brandid = null,
	sys_enterpriseid = null;

import {
	getLabelList
} from "../../utils/customItemType";

import {
	fileList
} from "../../utils/FormatTheAttachment";
import currency from "../../utils/currency";

Page({
	data: {
		itemCount: 0,
		selectCount: 0,
		labelList: getLabelList(),
		hidePrice: wx.getStorageSync('hidePrice'),
		badge: getApp().globalData.collectCount,
		favoriteCount: getApp().globalData.favoriteCount,
		loading: true,
		content: {
			sa_itemgroupid: null,
			spec: "", //规格
			color: "", //颜色
			material: "", //材质
			cheek: "" //边框
		},
		detail: {
			spec: ""
		},
	},
	onLoad(options) {
		let data = JSON.parse(options.params);
		sa_brandid = data.sa_brandid;
		if (wx.getStorageSync('userrole') == '业务员') sys_enterpriseid = data.sys_enterpriseid
		this.data.content.sa_itemgroupid = data.sa_itemgroupid;
		this.setData({
			userrole: wx.getStorageSync('userrole')
		})
		this.getDetail(true);
	},
	/* 获取详情 */
	getDetail(init = false) {
		let content = this.data.content;
		if (sys_enterpriseid) content.sys_enterpriseid = sys_enterpriseid;
		_Http.basic({
			"id": "20221223165503",
			content
		}).then(res => {
			wx.hideLoading();
			console.log("商品详情", res)
			if (res.msg != '成功') return wx.showToast({
				title: res.msg,
				icon: "none"
			})
			if (res.data.item.length == 0) return wx.showToast({
				title: '未查询到商品',
				icon: "none",
				mask: true
			})
			const item = res.data.item[0];
			this.handleFiles(item.attinfos)
			const CNY = sum => currency(sum, {
				symbol: "￥",
				precision: 2
			}).format();
			item.gradeprice = CNY(item.gradeprice);
			item.marketprice = CNY(item.marketprice);
			this.setData({
				content,
				detail: item,
				specRows: res.data.specRows.reverse(),
				cheekRows: res.data.cheekRows,
				materialRows: res.data.materialRows,
				colorRows: res.data.colorRows,
				loading: false,
				itemCount: ['specRows', 'cheekRows', 'materialRows', 'colorRows'].filter(v => res.data[v].length).length
			});
			//是否定制
			if (item.iscustomsize == 1) this.selectComponent("#customMade").init(item);
		})
	},
	/* 预览媒体 */
	viewMedias(e) {
		const {
			index,
			type
		} = e.currentTarget.dataset;
		wx.previewMedia({
			current: index,
			sources: type == 'image' ? this.data.files.viewImages : this.data.files.viewVideos,
		})
	},
	/* 处理附件 */
	handleFiles(arr) {
		let files = {
				images: [],
				viewImages: [],
				videos: [],
				viewVideos: [],
				files: []
			},
			list = fileList(arr);
		list.forEach(v => {
			switch (v.fileType) {
				case "video":
					files.videos.push(v)
					files.viewVideos.push({
						url: v.url,
						type: "video",
						poster: v.subfiles[0].url
					})
					break;
				case "image":
					files.images.push(v)
					files.viewImages.push({
						url: v.url,
						type: "image"
					})
					break;
				default:
					files.files.push(v)
					break;
			}
		});
		this.setData({
			files
		})
	},
	/* 切换产品 */
	changeItemno(e) {
		const {
			value,
			valuename
		} = e.currentTarget.dataset,
			content = this.data.content;
		if (!value.flag) return;
		wx.showLoading({
			title: '加载中...',
			mask: true
		})
		content[valuename] = (content[valuename] == value.parm) ? "" : value.parm;
		this.setData({
			selectCount: ['cheek', 'color', 'material', 'spec'].filter(v => content[v].length).length
		})
		this.getDetail(valuename == "spec")
	},

	clickBut() {
		this.data.detail.tradefield.length >= 2 ? wx.showToast({
			title: '请选择加入产品领域',
			icon: "none",
			duration: 3000
		}) : this.handleStorage(0);
	},
	/* 打开文档 */
	openDocument(e) {
		const {
			item
		} = e.currentTarget.dataset;
		console.log(item)
		wx.showLoading({
			title: '加载中...',
			mask: true,
		})
		wx.downloadFile({
			url: item.url,
			success: function (res) {
				const filePath = res.tempFilePath
				wx.openDocument({
					filePath: filePath,
					showMenu: true,
					fileType: item.postfix,
					success: function (res) {
						wx.hideLoading();
						console.log('打开文档成功')
					},
					fail(e) {
						console.log(e)
						wx.showToast({
							title: '打开失败',
							icon: "error",
							mask: true
						})
					}
				})
			},
			fail(e) {
				console.log(e)
				wx.showToast({
					title: '打开失败',
					icon: "error",
					mask: true
				})
			}
		})
	},
	clickBut(e) {
		this.data.detail.tradefield.length >= 2 ? wx.showToast({
			title: '请选择加入产品领域',
			icon: "none",
			duration: 3000
		}) : this[e.target.id](0);
	},
	/* 选择领域 */
	storage(e) {
		this.addToShoppingCart(e.detail.value)
	},
	/* 加入购物车 */
	addToShoppingCart(index) {
		let detail = this.data.detail,
			custom = {
				length: 0,
				width: 0
			};
		//是否为定制项
		if (detail.iscustomsize == 1) custom = this.selectComponent("#customMade").getResult(true);
		if (typeof custom == "boolean") return;
		let content = Object.assign(this.data.content, {
			sa_brandid,
			itemid: detail.itemid, //货品id
			qty: detail.orderminqty, //数量
			itemno: detail.itemno, //货品编号
			tradefield: detail.tradefield[index].tradefield,
		}, custom);

		_Http.basic({
			"id": 20220924095102,
			content,
		}).then(res => {
			console.log("加入购物车", res)
			wx.showToast({
				title: res.msg == '成功' ? '加入成功' : res.msg,
				icon: "none"
			});
			if (res.msg == '成功') getApp().globalData.getCollectCount().then(badge => this.setData({
				badge
			}))
		})
	},
	/* 加入收藏夹 */
	addToFavorites() {
		let detail = this.data.detail,
			iscollection = detail.iscollection == 1 ? false : true,
			custom = {
				width: 0,
				length: 0,
			},
			favorites = {};
		//是否为定制项
		if (detail.iscustomsize == 1) custom = this.selectComponent("#customMade").getResult(true);
		for (const key in custom) {
			favorites['favorites' + key] = custom[key]
		}
		if (typeof custom == "boolean") return;
		_Http.basic({
			"id": 20231121143403,
			"content": {
				"itemid": this.data.detail.itemid, //货品id
				"qty": detail.orderminqty, //数量
				...custom,
				iscollection,
				...favorites
			},
		}).then(res => {
			console.log(iscollection + "收藏夹", res)
			wx.showToast({
				title: res.msg == '成功' ? iscollection ? '收藏成功' : "已取消收藏" : res.msg,
				icon: "none"
			});
			if (res.msg == '成功') {
				getApp().globalData.getFavoriteCount().then(num => {
					this.setData({
						favoriteCount: num
					})
				})
				this.setData({
					"detail.iscollection": iscollection ? 1 : 0
				})
			}
		})
	},
	/* 前往购物车 */
	toCollect(e) {
		getApp().globalData.changeBar({
			detail: "Collect"
		})
		wx.navigateBack();
	}
})